package code;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.security.NoSuchAlgorithmException;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.sun.net.httpserver.HttpExchange;
import com.sun.net.httpserver.HttpHandler;

import db.DBC;
import db.Dominio;

public class InstallHandler implements HttpHandler {

	@Override
	public void handle(HttpExchange he) throws IOException {

		// URI requestedUri = he.getRequestURI();
		String requestMethod = he.getRequestMethod();

		if (requestMethod.compareToIgnoreCase("options") == 0) {
			he.getResponseHeaders().add("Access-Control-Allow-Origin", "*");// se non mettiamo *, viene errore CORS
																			// //http://localhost:3001/secured/domains
			he.getResponseHeaders().add("Access-Control-Allow-Methods", "GET, POST, OPTIONS");
			he.getResponseHeaders().add("Access-Control-Allow-Headers", "Content-Type,Authorization");
			he.sendResponseHeaders(200, -1);
			return;
		}

		// String response = "";

		// String query = requestedUri.getRawQuery();
		String body = readBody(he.getRequestBody());

		// he.getRequestHeaders().get("user").get(0);

		String user;

		try {
			String token = he.getRequestHeaders().get("Authorization").get(0).substring(7);
			// JSONObject tok=new JSONObject(token);
			// String accessToken=tok.getString("access_token");
			String[] tokSplit = token.split("[.]");
			if (tokSplit.length != 3)
				return;// controllo che il token abbia header,body e signature(abbia 2 punti :s)
			// int scnddot=accessToken.lastIndexOf(".");//dopo questo indice è tutta
			// signature
			String signature = tokSplit[2];
			user = TokenHandler.verificaToken(token, signature);
			if (user == null) {
				he.sendResponseHeaders(401, -1);
				he.getResponseHeaders().add("Access-Control-Allow-Origin", "*");// http://localhost:3001/secured/domains
				he.getResponseHeaders().add("Access-Control-Allow-Methods", "GET, POST, OPTIONS");// non c'era POST
				he.getResponseHeaders().add("Access-Control-Allow-Headers", "Content-Type,Authorization");
				// questa parte sopra serve anche qui, non solo quando si chiama con OPTIONS
				return;
			}

		} catch (NoSuchAlgorithmException | IOException | JSONException e2) {
			e2.printStackTrace();
			return;
		}

		// verifica user

		if (requestMethod.compareToIgnoreCase("POST") == 0) {

			JSONObject j = null;
			try {
				j = new JSONObject(body);
				String dm = j.getString("domain");

				// try {

				Dominio d = DBC.getDom(dm);
				if (d != null) {

					// String response = "DOMINIO GIA' IN USO";
					OutputStream os = he.getResponseBody();
					he.getResponseHeaders().add("Access-Control-Allow-Origin", "*");// http://localhost:3001/secured/domains
					he.getResponseHeaders().add("Access-Control-Allow-Methods", "GET, POST, OPTIONS");// non c'era POST
					he.getResponseHeaders().add("Access-Control-Allow-Headers", "Content-Type,Authorization");
					// questa parte sopra serve anche qui, non solo quando si chiama con OPTIONS
					he.sendResponseHeaders(403, -1);// response.getBytes().length);
					// os.write(response.getBytes());
					os.close();
					return;
				}

			} catch (JSONException | SQLException e) {
				e.printStackTrace();
				return;
			}

			// inserisco i dati nel DB

			// String s = user + "-A";
			try {

				// qui leggo e parsifico i json nel body, inserisco tutti i campi nel db

				String domain = j.getString("domain");
				DBC.insertDom(domain);
				// questa chiamata serve ad assicurarsi che l'utente che ha effettuato la
				// chiamata sia anche amministratore del dominio
				DBC.insertAmministra(user, domain);

				JSONArray arrUsers = j.getJSONArray("users");
				for (int i = 0; i < arrUsers.length(); i++) {
					JSONObject userObj = arrUsers.getJSONObject(i);
					String usr = userObj.getString("user");
					if (user.equals(usr))
						continue;
					if (userObj.getString("role").equals("A")) {
						DBC.insertAmministra(usr, domain);
					} else if (userObj.getString("role").equals("U")) {
						DBC.insertUsa(usr, domain);
					} else
						System.err.println(userObj.toString());
				}

				JSONArray arrServ = j.getJSONArray("services");//array con solo il nome dei servizi da installare
				ArrayList<String> moduleHosts = new ArrayList<String>();
				for (int i = 0; i < arrServ.length(); i++) {

					// String modul=((JSONObject) arrUsers.get(i)).getString("service");
					// String host=((JSONObject) arrUsers.get(i)).getString("host");
					// DBC.insertService(domain,host,modul);
					String modul = arrServ.getString(i);
					moduleHosts.addAll(DBC.insertService(domain, modul));
				}
				// divido gli host in base al loro module
				HashMap<String, ArrayList<String>> hostsMap = new HashMap<String, ArrayList<String>>();
				for (String mh : moduleHosts) {
					String[] mhSplit = mh.split("---");
					String module = mhSplit[0];
					String host = mhSplit[1];
					ArrayList<String> hostsList;
					if (hostsMap.containsKey(module)) {
						hostsList = hostsMap.get(module);
					} else {
						hostsList = new ArrayList<String>();
						hostsMap.put(module, hostsList);
					}
					hostsList.add(host);
				}
				// imposta correttamente l'array dei servizi
				JSONArray arrServiziFinale = new JSONArray();
				for(int i=0; i < arrServ.length(); i++) {
					JSONObject row = new JSONObject();
					String mod = arrServ.getString(i);
					ArrayList<String> ho = hostsMap.get(mod);
					for(String h : ho) {
						row.put("host", h);
						row.put("service", mod);
						row.put("uri", DBC.getURI(mod));
						arrServiziFinale.put(row);
					}
				}
				j.put("services", arrServiziFinale);
				System.out.println("about to send: " + j.toString());
				// non ci sono controlli!!!!

			} catch (SQLException | JSONException e) {
				e.printStackTrace();
			}

			// ora bisogna fare la chiamata al CloudApp, non prima!
			// effettuo chiamata a CloudAppManager
			// preso da https://www.baeldung.com/java-http-request

			// è una chiamata annidata nella risposta alla webapp
			// -richiesta REST da webApp a /install
			// -prendo da DB e poi chiamo CloudAppMng su /install
			// -attendo risposta da CloudAppMng e chiudo
			// -rispondo a webApp e chiudo
			// EZ

			//
			// standard per chiamata in slide
			// https://www.dir.uniupo.it/pluginfile.php/948883/mod_resource/content/1/FrameworkProgetto5.pdf
			//
			// http://127.0.0.1:8080/install

			// 3002/install da inserire
			URL url = new URL("http://127.0.0.1:3002/install");// maybe, se CloudAppe è in localhost porta 8080
			HttpURLConnection con = (HttpURLConnection) url.openConnection();

			con.setRequestMethod("POST");
			con.setRequestProperty("Content-Type", "application/json");
			con.setRequestProperty("Accept", "application/json");
			con.setDoOutput(true);
			con.setConnectTimeout(5000);
			con.setReadTimeout(5000);
			DataOutputStream outForCloudApp = new DataOutputStream(con.getOutputStream());// inserimento param
																							// in call
			outForCloudApp.writeBytes(j.toString());
			outForCloudApp.flush();
			outForCloudApp.close();

			// con.setRequestProperty("Content-Type", "application/json");
			// String contentType = con.getHeaderField("Content-Type");
			// leggo risposta
			int status = con.getResponseCode();
			BufferedReader in = new BufferedReader(new InputStreamReader(con.getInputStream()));
			String inputLine;
			StringBuffer content = new StringBuffer();
			while ((inputLine = in.readLine()) != null) {
				content.append(inputLine);
			}
			in.close();
			con.disconnect();

			// finita chiamata a CloudApp

			// f.close();
			//risposta alla webapp
			OutputStream os = he.getResponseBody();
			he.getResponseHeaders().add("Access-Control-Allow-Origin", "*");// http://localhost:3001/secured/domains
			he.getResponseHeaders().add("Access-Control-Allow-Methods", "GET, POST, OPTIONS");// non c'era POST
			he.getResponseHeaders().add("Access-Control-Allow-Headers", "Content-Type,Authorization");
			// questa parte sopra serve anche qui, non solo quando si chiama con OPTIONS
			// String response = content.toString();// {"result":"done"}
			he.sendResponseHeaders(status, -1);// response.getBytes().length);
			// os.write(response.getBytes());

			// he.sendResponseHeaders(status, response.length());//status
			// os.write(response.getBytes());
			os.close();
		}
	}

	private String readBody(InputStream requestBody) {
		int req;
		StringBuffer sb = new StringBuffer();
		try {
			while ((req = requestBody.read()) != -1)
				sb.append(Character.toString((char) req));
		} catch (IOException e) {
			e.printStackTrace();
		}
		return sb.toString();
	}

}
