package code;


import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.UnsupportedEncodingException;
import java.net.URI;
import java.net.URLDecoder;
import java.security.NoSuchAlgorithmException;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.sun.net.httpserver.HttpExchange;
import com.sun.net.httpserver.HttpHandler;

import db.DBC;


public class ServicesHandler implements HttpHandler{


	public void handle(HttpExchange he) throws IOException {
		System.out.println("INIZIOSERVICESHANDLER");
		URI requestedUri = he.getRequestURI();
		String requestMethod = he.getRequestMethod();

		if (requestMethod.compareToIgnoreCase("options") == 0) {
			System.out.println("OPTIONS");
			he.getResponseHeaders().add("Access-Control-Allow-Origin", "*");// se non mettiamo *, viene errore CORS //http://localhost:3001/secured/domains
			he.getResponseHeaders().add("Access-Control-Allow-Methods", "GET, POST, OPTIONS");
			he.getResponseHeaders().add("Access-Control-Allow-Headers", "Content-Type,Authorization");
			he.sendResponseHeaders(200, -1);
			return;
		}

		String response = "";

		String query = requestedUri.getRawQuery();
		System.out.println("Query: " + query);
		// String body = readBody(he.getRequestBody());
		String user;

		Map<String, Object> parameters = new HashMap<String, Object>();
		parseQuery(query, parameters);
		String domain=(String) parameters.get("domain");

		// String user = he.getRequestHeaders().get("user").get(0);
		// System.out.println("token: " + token);
		try {
			String token = he.getRequestHeaders().get("Authorization").get(0).substring(7);// taglio bearer
			//JSONObject tok=new JSONObject(token);
			//String accessToken=tok.getString("access_token");
			String[] tokSplit=token.split("[.]");
			if(tokSplit.length!=3)return;//controllo che il token abbia header,body e signature(abbia 2 punti :s)
			//int scnddot=accessToken.lastIndexOf(".");//dopo questo indice è tutta signature
			String signature=tokSplit[2];
			user=TokenHandler.verificaToken(token,signature);

			if(user == null){
				he.sendResponseHeaders(401, -1);
				he.getResponseHeaders().add("Access-Control-Allow-Origin", "*");//http://localhost:3001/secured/domains
				he.getResponseHeaders().add("Access-Control-Allow-Methods", "GET, POST, OPTIONS");//non c'era POST
				he.getResponseHeaders().add("Access-Control-Allow-Headers", "Content-Type,Authorization");
				// questa parte sopra serve anche qui, non solo quando si chiama con OPTIONS
				return;
			}


		} catch (NoSuchAlgorithmException | IOException | JSONException e2) {
			e2.printStackTrace();
			return;
		}




		if (requestMethod.compareToIgnoreCase("GET") == 0) {
			System.out.println("GET");
			JSONObject res = new JSONObject();
			if(domain != null){
				// I have to send only the services used by this domain

				JSONArray rs =null;

				//ArrayList<String> modulesList;
				try {
					//modulesList = DBC.getModules();

					//for (String k : modulesList) {
					//	rs.put(k);
					rs= DBC.getServicesInUseByDomain(domain);
					res.put("response", rs);
					System.out.println("ciao! "+res.toString());

				} catch (SQLException | JSONException e) {
					e.printStackTrace();
				}



			} else {
				// I have to send all available services
				JSONArray rs = DBC.getAllServices();
				try {
					res.put("response",rs);
				} catch (JSONException e) {
					e.printStackTrace();
				}

			}
			response = res.toString();

			// questa parte sopra serve anche qui, non solo quando si chiama con OPTIONS

			OutputStream os = he.getResponseBody();
			he.getResponseHeaders().add("Access-Control-Allow-Origin", "*");//http://localhost:3001/secured/domains
			he.getResponseHeaders().add("Access-Control-Allow-Methods", "GET, POST, OPTIONS");//non c'era POST
	        he.getResponseHeaders().add("Access-Control-Allow-Headers", "Content-Type,Authorization");
			he.sendResponseHeaders(200, response.getBytes().length);
			os.write(response.getBytes());
			// he.sendResponseHeaders(status, response.length());//status
			// os.write(response.getBytes());
			os.close();

			// JSONObject j=new JSONObject();
			// j.append("User", DBC.getDomainsUser(user));

			// j=(""+":"+);


		}

	}

	private String readBody(InputStream requestBody) {
		int req;
		StringBuffer sb = new StringBuffer();
		try {
			while ((req = requestBody.read()) != -1)
				sb.append(Character.toString((char) req));
		} catch (IOException e) {
			e.printStackTrace();
		}
		return sb.toString();
	}


	void parseQuery(String query, Map<String, Object> parameters) throws UnsupportedEncodingException {

		if (query != null) {
			String pairs[] = query.split("[&]");
			for (String pair : pairs) {
				String param[] = pair.split("[=]");
				String key = null;
				String value = null;
				if (param.length > 0) {
					key = URLDecoder.decode(param[0], System.getProperty("file.encoding"));
				}

				if (param.length > 1) {
					value = URLDecoder.decode(param[1], System.getProperty("file.encoding"));
				}

				if (parameters.containsKey(key)) {
					Object obj = parameters.get(key);
					if (obj instanceof List<?>) {
						List<String> values = (List<String>) obj;
						values.add(value);

					} else if (obj instanceof String) {
						List<String> values = new ArrayList<String>();
						values.add((String) obj);
						values.add(value);
						parameters.put(key, values);
					}
				} else {
					parameters.put(key, value);
				}
			}
		}
	}










































}
